/**
  Generated main.c file from MPLAB Code Configurator

  @Company
    Microchip Technology Inc.

  @File Name
    main.c

  @Summary
    This is the generated main.c using PIC24 / dsPIC33 / PIC32MM MCUs.

  @Description
    This source file provides main entry point for system initialization and application code development.
    Generation Information :
        Product Revision  :  PIC24 / dsPIC33 / PIC32MM MCUs - 1.170.0
        Device            :  PIC24FJ64GA004
    The generated drivers are tested against the following:
        Compiler          :  XC16 v1.61
        MPLAB 	          :  MPLAB X v5.45
*/

/*
    (c) 2020 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/
#define     FCY         16000000UL
/**
  Section: Included Files
*/
#include "mcc_generated_files/system.h"
#include "mcc_generated_files/adc1.h"
#include "mcc_generated_files/oc1.h"
#include <libpic30.h>

/*
                         Main application
 */
#define     LCD_RST     LATBbits.LATB7      //RB7
#define     LCD_CS      LATBbits.LATB5      //RB5
#define     LCD_WR      LATBbits.LATB3      //RB3
#define     LCD_DC      LATBbits.LATB6      //RB6
#define     LCD_RD      LATBbits.LATB2      //RB2

#define     SW1         PORTBbits.RB10
#define     SW2         PORTBbits.RB11
#define     SW3         PORTBbits.RB12

#define     TEST_PORT   PORTBbits.RB13

#define     I2C_EEPROM  (0x50 << 1)

unsigned char	data[4];

unsigned int    ad0_level;
unsigned int    ad1_level;
unsigned int    l_level;
unsigned int    r_level;

unsigned char disp_ram[7680];
unsigned char disp_u_level[26];
unsigned char disp_d_level[26];

unsigned char   mode;
unsigned char   disp_no;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw3_cnt;

unsigned int    light;

//const unsigned char color_data1[15]={8,248,15,8,255,248,15,255,127,120,15,251,248,11,123};
//const unsigned char color_data2[15]={33,33,225,63,225,63,255,255,225,63,239,225,47,255,239};
const unsigned char color_data1[15]={0,248,7,0,255,248,7,255,127,120,7,251,248,3,123};
const unsigned char color_data2[15]={0,0,224,31,224,31,255,255,224,31,239,224,15,255,239};

const unsigned char color_palet[7][4]={{7,1,4,3},{11,9,12,7},{5,4,2,12},{13,1,6,9},{4,11,10,3},{8,3,1,4},{1,8,9,6}};

const unsigned char vu_font_no[12]={2,5,7,9,24,26,28,30,32,34,36,38};

const unsigned char vu_data[256]={
0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,2,2,3,3,4,4,4,5,5,5,6,6,6,7,7,7,
8,8,8,8,9,9,9,9,10,10,10,10,10,11,11,11,11,11,11,12,12,12,12,12,12,13,13,13,13,13,13,13,
13,14,14,14,14,14,14,14,15,15,15,15,15,15,15,15,15,16,16,16,16,16,16,16,16,16,17,17,17,17,17,17,
17,17,17,17,17,17,18,18,18,18,18,18,18,18,18,18,18,18,19,19,19,19,19,19,19,19,19,19,19,19,19,19,
20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,21,
21,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,23,23,23,23,23,23,23,23,23,23,23,23,
23,23,23,23,23,23,23,23,23,23,23,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,
24,24,24,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25,25    
};

const unsigned char vu_data_2[256]={
0,0,0,0,0,0,1,1,2,2,2,3,3,3,3,3,4,4,4,4,4,4,4,5,5,5,5,5,5,5,5,5,
6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,7,
7,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,9,9,9,9,9,9,
9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,
10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,
10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,11,11,11,11,11,11,11,
11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,
11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11,11    
};
const unsigned char vu_font[53][144]={
//L
{0,0,0,0,0,0,
0,85,85,85,85,0,
1,85,85,85,85,64,
5,90,170,170,165,80,
21,106,170,170,169,84,
21,175,234,170,170,84,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,234,170,170,148,
22,175,250,170,170,148,
22,175,255,255,250,148,
22,175,255,255,250,148,
21,171,255,255,250,84,
21,106,170,170,169,84,
5,90,170,170,165,80,
1,85,85,85,85,64,
0,85,85,85,85,0,
0,0,0,0,0,0,
},
//R
{0,0,0,0,0,0,
0,85,85,85,85,0,
1,85,85,85,85,64,
5,90,170,170,165,80,
21,106,170,170,169,84,
21,175,255,255,234,84,
22,175,255,255,250,148,
22,175,255,255,250,148,
22,175,234,171,250,148,
22,175,234,171,250,148,
22,175,234,171,250,148,
22,175,255,255,250,148,
22,175,255,255,234,148,
22,175,255,255,170,148,
22,175,234,191,170,148,
22,175,234,175,234,148,
22,175,234,175,250,148,
22,175,234,171,250,148,
21,175,234,171,250,84,
21,106,170,170,169,84,
5,90,170,170,165,80,
1,85,85,85,85,64,
0,85,85,85,85,0,
0,0,0,0,0,0,
},
//
{0,0,0,0,0,0,
0,85,85,85,85,0,
1,85,85,85,85,64,
5,90,170,170,165,80,
21,106,170,170,169,84,
21,170,170,170,170,84,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
21,170,170,170,170,84,
21,106,170,170,169,84,
5,90,170,170,165,80,
1,85,85,85,85,64,
0,85,85,85,85,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,85,85,85,85,0,
1,85,85,85,85,64,
5,95,255,255,245,80,
21,127,255,255,253,84,
21,255,255,255,255,84,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
21,255,255,255,255,84,
21,127,255,255,253,84,
5,95,255,255,245,80,
1,85,85,85,85,64,
0,85,85,85,85,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,1,64,0,0,
0,0,5,80,0,0,
0,0,21,84,0,0,
0,0,21,84,0,0,
0,0,21,84,0,0,
0,0,5,80,0,0,
0,0,1,64,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
21,0,0,0,0,0,
21,80,0,0,0,0,
21,85,0,0,0,0,
22,85,80,0,0,0,
22,165,85,0,0,0,
22,170,85,80,0,0,
22,170,165,85,0,0,
22,170,170,85,80,0,
22,170,170,165,84,0,
22,170,170,170,85,64,
22,170,170,170,165,84,
22,170,170,170,165,84,
22,170,170,170,85,64,
22,170,170,165,84,0,
22,170,170,85,80,0,
22,170,165,85,0,0,
22,170,85,80,0,0,
22,165,85,0,0,0,
22,85,80,0,0,0,
21,85,0,0,0,0,
21,80,0,0,0,0,
21,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
21,0,0,0,0,0,
21,80,0,0,0,0,
21,85,0,0,0,0,
23,85,80,0,0,0,
23,245,85,0,0,0,
23,255,85,80,0,0,
23,255,245,85,0,0,
23,255,255,85,80,0,
23,255,255,245,84,0,
23,255,255,255,85,64,
23,255,255,255,245,84,
23,255,255,255,245,84,
23,255,255,255,85,64,
23,255,255,245,84,0,
23,255,255,85,80,0,
23,255,245,85,0,0,
23,255,85,80,0,0,
23,245,85,0,0,0,
23,85,80,0,0,0,
21,85,0,0,0,0,
21,80,0,0,0,0,
21,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
5,85,80,5,85,80,
21,85,84,21,85,84,
21,170,84,21,170,84,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
22,170,148,22,170,148,
21,170,84,21,170,84,
21,85,84,21,85,84,
5,85,80,5,85,80,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
5,85,80,5,85,80,
21,85,84,21,85,84,
21,255,84,21,255,84,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
23,255,212,23,255,212,
21,255,84,21,255,84,
21,85,84,21,85,84,
5,85,80,5,85,80,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,1,64,0,0,
0,0,1,80,0,0,
0,0,1,84,0,0,
0,0,1,85,0,0,
0,0,1,101,64,0,
21,85,85,105,80,0,
21,85,85,106,84,0,
22,170,170,170,149,0,
22,170,170,170,165,64,
22,170,170,170,169,80,
22,170,170,170,170,84,
22,170,170,170,170,84,
22,170,170,170,169,80,
22,170,170,170,165,64,
22,170,170,170,149,0,
21,85,85,106,84,0,
21,85,85,105,80,0,
0,0,1,101,64,0,
0,0,1,85,0,0,
0,0,1,84,0,0,
0,0,1,80,0,0,
0,0,1,64,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,1,64,0,0,
0,0,1,80,0,0,
0,0,1,84,0,0,
0,0,1,85,0,0,
0,0,1,117,64,0,
21,85,85,125,80,0,
21,85,85,127,84,0,
23,255,255,255,213,0,
23,255,255,255,245,64,
23,255,255,255,253,80,
23,255,255,255,255,84,
23,255,255,255,255,84,
23,255,255,255,253,80,
23,255,255,255,245,64,
23,255,255,255,213,0,
21,85,85,127,84,0,
21,85,85,125,80,0,
0,0,1,117,64,0,
0,0,1,85,0,0,
0,0,1,84,0,0,
0,0,1,80,0,0,
0,0,1,64,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,5,85,80,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,21,0,0,0,84,
0,21,0,0,0,84,
0,21,0,0,0,84,
5,85,84,0,85,84,
5,85,84,0,85,84,
5,85,84,0,85,84,
0,21,0,0,0,84,
0,21,0,0,0,84,
0,21,0,0,0,84,
0,0,0,0,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,5,85,80,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,5,85,80,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
5,85,84,0,85,84,
5,85,84,0,85,84,
5,85,84,0,85,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,5,85,80,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,0,
0,0,0,21,0,0,
0,0,0,21,0,0,
5,85,84,21,85,80,
5,85,84,21,85,84,
5,85,84,21,85,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,5,85,80,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
5,85,84,21,85,84,
5,85,84,21,85,84,
5,85,84,5,85,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,0,0,84,
0,0,0,21,0,84,
0,0,0,21,0,84,
0,0,0,21,85,84,
0,0,0,21,85,84,
0,0,0,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,84,5,85,80,
0,0,84,21,85,84,
0,0,84,21,85,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
5,80,84,5,85,84,
5,80,84,21,85,84,
5,80,84,21,85,80,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,85,84,
0,0,84,21,85,84,
0,0,84,5,85,84,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,84,5,85,84,
0,0,84,21,85,84,
0,0,84,21,85,84,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
0,0,84,21,0,0,
5,80,84,21,85,80,
5,80,84,21,85,84,
5,80,84,5,85,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,85,84,
0,0,84,21,85,84,
0,0,84,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,84,5,85,80,
0,0,84,21,85,84,
0,0,84,21,85,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
5,80,84,21,85,84,
5,80,84,21,85,84,
5,80,84,21,85,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,0,84,
0,0,84,21,85,84,
0,0,84,21,85,84,
0,0,84,5,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,21,85,0,84,
0,0,85,85,64,84,
0,0,85,85,64,84,
0,0,84,5,64,84,
0,0,84,5,64,84,
0,0,0,5,64,84,
0,0,0,5,64,84,
0,0,0,5,64,84,
5,80,21,85,64,84,
5,80,85,85,64,84,
5,80,85,85,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,84,0,0,84,
0,0,85,85,64,84,
0,0,85,85,64,84,
0,0,21,85,64,84,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,21,85,5,64,84,
0,85,85,69,64,84,
0,85,85,69,64,84,
0,84,5,69,64,84,
0,84,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
20,21,85,69,85,84,
20,85,85,69,85,84,
20,85,85,5,85,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,85,85,64,0,84,
0,85,85,64,0,84,
0,21,85,64,0,84,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,21,85,5,85,84,
0,85,85,69,85,84,
0,85,85,69,85,84,
0,84,5,69,64,84,
0,84,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
0,0,5,64,0,84,
20,21,85,64,0,84,
20,85,85,64,0,84,
20,85,85,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,84,0,0,0,84,
0,85,85,64,0,84,
0,85,85,64,0,84,
0,21,85,64,0,84,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,21,85,1,85,80,
0,85,85,69,85,84,
0,85,85,69,85,84,
0,84,5,69,64,84,
0,84,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
20,1,85,69,64,84,
20,1,85,69,64,84,
20,1,85,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
0,0,5,69,64,84,
0,84,5,69,64,84,
0,84,5,69,64,84,
0,85,85,69,85,84,
0,85,85,69,85,84,
0,21,85,1,85,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
20,0,0,0,0,0,
21,64,0,0,0,0,
21,84,0,0,0,0,
22,85,64,0,0,0,
22,165,84,0,0,0,
22,170,85,0,0,0,
22,170,165,80,0,0,
22,170,170,80,0,0,
22,170,165,80,0,0,
22,170,85,85,0,0,
22,165,85,149,80,0,
22,85,69,169,85,0,
21,84,5,170,149,64,
21,64,5,170,169,84,
20,0,5,170,170,148,
0,0,5,170,169,84,
0,0,5,170,149,64,
0,0,5,169,85,0,
0,0,5,149,80,0,
0,0,5,85,0,0,
0,0,5,80,0,0,
0,0,5,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
20,0,0,0,0,0,
21,64,0,0,0,0,
21,84,0,0,0,0,
23,85,64,0,0,0,
23,245,84,0,0,0,
23,255,85,0,0,0,
23,255,245,80,0,0,
23,255,255,80,0,0,
23,255,245,80,0,0,
23,255,85,85,0,0,
23,245,85,213,80,0,
23,85,69,253,85,0,
21,84,5,255,213,64,
21,64,5,255,253,84,
20,0,5,255,255,212,
0,0,5,255,253,84,
0,0,5,255,213,64,
0,0,5,253,85,0,
0,0,5,213,80,0,
0,0,5,85,0,0,
0,0,5,80,0,0,
0,0,5,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,1,85,85,64,0,
0,21,85,85,84,0,
0,85,170,170,85,0,
1,90,170,170,165,64,
5,106,170,170,169,80,
5,170,170,170,170,80,
21,170,170,170,170,84,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,150,148,
22,170,170,170,150,148,
22,170,170,170,150,148,
22,170,170,170,150,148,
22,170,170,170,150,148,
22,170,170,170,170,148,
21,170,170,169,106,84,
5,170,170,169,106,80,
5,106,169,90,169,80,
1,90,169,90,165,64,
0,85,170,170,85,0,
0,21,85,85,84,0,
0,1,85,85,64,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,1,85,85,64,0,
0,21,85,85,84,0,
0,85,255,255,85,0,
1,95,255,255,245,64,
5,127,255,255,253,80,
5,255,255,255,255,80,
21,255,255,255,255,84,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,215,212,
23,255,255,255,215,212,
23,255,255,255,215,212,
23,255,255,255,215,212,
23,255,255,255,215,212,
23,255,255,255,255,212,
21,255,255,253,127,84,
5,255,255,253,127,80,
5,127,253,95,253,80,
1,95,253,95,245,64,
0,85,255,255,85,0,
0,21,85,85,84,0,
0,1,85,85,64,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
20,0,1,64,0,0,
21,0,1,80,0,0,
21,64,1,84,0,0,
21,80,1,85,0,0,
22,84,1,101,64,0,
22,149,1,105,80,0,
22,165,65,106,84,0,
22,169,81,106,149,0,
22,170,85,106,165,64,
22,170,149,106,169,80,
22,170,165,106,170,84,
22,170,165,106,170,84,
22,170,149,106,169,80,
22,170,85,106,165,64,
22,169,81,106,149,0,
22,165,65,106,84,0,
22,149,1,105,80,0,
22,84,1,101,64,0,
21,80,1,85,0,0,
21,64,1,84,0,0,
21,0,1,80,0,0,
20,0,1,64,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
20,0,1,64,0,0,
21,0,1,80,0,0,
21,64,1,84,0,0,
21,80,1,85,0,0,
23,84,1,117,64,0,
23,213,1,125,80,0,
23,245,65,127,84,0,
23,253,81,127,213,0,
23,255,85,127,245,64,
23,255,213,127,253,80,
23,255,245,127,255,84,
23,255,245,127,255,84,
23,255,213,127,253,80,
23,255,85,127,245,64,
23,253,81,127,213,0,
23,245,65,127,84,0,
23,213,1,125,80,0,
23,84,1,117,64,0,
21,80,1,85,0,0,
21,64,1,84,0,0,
21,0,1,80,0,0,
20,0,1,64,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,21,84,0,0,
0,1,85,85,64,0,
0,5,90,165,80,0,
0,21,169,106,84,0,
0,86,165,90,149,0,
0,90,169,106,165,0,
1,90,170,170,165,64,
1,106,170,170,169,64,
1,106,170,170,169,64,
1,106,170,170,169,64,
1,106,170,170,169,64,
1,90,170,170,165,64,
0,90,170,170,165,0,
0,86,170,170,149,0,
0,21,170,170,84,0,
0,5,90,165,80,0,
0,1,85,85,64,0,
0,0,21,84,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,21,84,0,0,
0,1,85,85,64,0,
0,5,95,245,80,0,
0,21,253,127,84,0,
0,87,245,95,213,0,
0,95,253,127,245,0,
1,95,255,255,245,64,
1,127,255,255,253,64,
1,127,255,255,253,64,
1,127,255,255,253,64,
1,127,255,255,253,64,
1,95,255,255,245,64,
0,95,255,255,245,0,
0,87,255,255,213,0,
0,21,255,255,84,0,
0,5,95,245,80,0,
0,1,85,85,64,0,
0,0,21,84,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,1,64,0,0,
0,0,5,80,0,0,
0,0,21,84,0,0,
0,0,86,149,0,0,
0,1,90,165,64,0,
0,5,106,169,80,0,
0,21,170,170,84,0,
0,86,170,170,149,0,
1,90,170,170,165,64,
5,106,170,170,169,80,
21,170,170,170,170,84,
21,170,170,170,170,84,
5,106,170,170,169,80,
1,90,170,170,165,64,
0,86,170,170,149,0,
0,21,170,170,84,0,
0,5,106,169,80,0,
0,1,90,165,64,0,
0,0,86,149,0,0,
0,0,21,84,0,0,
0,0,5,80,0,0,
0,0,1,64,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,1,64,0,0,
0,0,5,80,0,0,
0,0,21,84,0,0,
0,0,87,213,0,0,
0,1,95,245,64,0,
0,5,127,253,80,0,
0,21,255,255,84,0,
0,87,255,255,213,0,
1,95,255,255,245,64,
5,127,255,255,253,80,
21,255,255,255,255,84,
21,255,255,255,255,84,
5,127,255,255,253,80,
1,95,255,255,245,64,
0,87,255,255,213,0,
0,21,255,255,84,0,
0,5,127,253,80,0,
0,1,95,245,64,0,
0,0,87,213,0,0,
0,0,21,84,0,0,
0,0,5,80,0,0,
0,0,1,64,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,5,80,0,0,
0,0,21,84,0,0,
0,0,86,149,0,0,
0,0,90,165,0,0,
0,0,90,165,0,0,
0,85,90,165,85,0,
1,85,90,165,85,64,
5,106,170,170,169,80,
21,170,170,170,170,84,
21,169,105,105,106,84,
22,169,105,105,106,148,
22,169,105,105,106,148,
21,169,105,105,106,84,
21,170,170,170,170,84,
5,106,170,170,169,80,
1,85,90,165,85,64,
0,85,90,165,85,0,
0,0,90,165,0,0,
0,0,90,165,0,0,
0,0,86,149,0,0,
0,0,21,84,0,0,
0,0,5,80,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,5,80,0,0,
0,0,21,84,0,0,
0,0,87,213,0,0,
0,0,95,245,0,0,
0,0,95,245,0,0,
0,85,95,245,85,0,
1,85,95,245,85,64,
5,127,255,255,253,80,
21,255,255,255,255,84,
21,253,125,125,127,84,
23,253,125,125,127,212,
23,253,125,125,127,212,
21,253,125,125,127,84,
21,255,255,255,255,84,
5,127,255,255,253,80,
1,85,95,245,85,64,
0,85,95,245,85,0,
0,0,95,245,0,0,
0,0,95,245,0,0,
0,0,87,213,0,0,
0,0,21,84,0,0,
0,0,5,80,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,21,85,85,84,0,
1,85,85,85,85,64,
5,86,170,170,149,80,
21,106,170,170,169,84,
21,170,165,90,170,84,
21,170,165,90,170,84,
21,106,170,170,169,84,
5,86,170,170,149,80,
1,85,85,85,85,64,
0,21,85,85,84,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,21,85,85,84,0,
1,85,85,85,85,64,
5,86,170,170,149,80,
21,106,170,170,169,84,
21,170,165,90,170,84,
21,170,165,90,170,84,
21,106,170,170,169,84,
5,86,170,170,149,80,
1,85,85,85,85,64,
0,21,85,85,84,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,21,85,85,84,0,
1,85,85,85,85,64,
5,87,255,255,213,80,
21,127,255,255,253,84,
21,255,245,95,255,84,
21,255,245,95,255,84,
21,127,255,255,253,84,
5,87,255,255,213,80,
1,85,85,85,85,64,
0,21,85,85,84,0,
0,0,0,0,0,0,
0,0,0,0,0,0,
0,21,85,85,84,0,
1,85,85,85,85,64,
5,87,255,255,213,80,
21,127,255,255,253,84,
21,255,245,95,255,84,
21,255,245,95,255,84,
21,127,255,255,253,84,
5,87,255,255,213,80,
1,85,85,85,85,64,
0,21,85,85,84,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,21,84,0,0,
0,5,85,85,80,0,
0,85,90,165,85,0,
1,86,170,170,149,64,
5,106,170,170,169,80,
5,170,170,170,170,80,
21,165,90,165,90,84,
22,149,86,149,86,148,
22,148,22,148,22,148,
22,148,22,148,22,148,
22,149,86,149,86,148,
22,165,90,165,90,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,170,170,170,170,148,
22,149,86,149,86,148,
22,149,86,149,86,148,
22,148,22,148,22,148,
22,148,22,148,22,148,
21,84,21,84,21,84,
21,84,21,84,21,84,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,21,84,0,0,
0,5,85,85,80,0,
0,85,95,245,85,0,
1,87,255,255,213,64,
5,127,255,255,253,80,
5,255,255,255,255,80,
21,245,95,245,95,84,
23,213,87,213,87,212,
23,212,23,212,23,212,
23,212,23,212,23,212,
23,213,87,213,87,212,
23,245,95,245,95,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,255,255,255,255,212,
23,213,87,213,87,212,
23,213,87,213,87,212,
23,212,23,212,23,212,
23,212,23,212,23,212,
21,84,21,84,21,84,
21,84,21,84,21,84,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,64,5,85,64,
1,85,64,21,85,80,
1,85,64,21,85,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
0,5,64,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,85,85,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,84,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,85,85,21,1,80,
1,85,85,21,1,80,
1,85,84,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
0,85,85,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,84,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,5,85,21,1,80,
0,5,85,21,1,80,
0,5,85,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
0,85,84,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,80,21,5,85,64,
1,80,21,21,85,80,
1,80,21,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,1,80,
1,85,85,21,1,80,
0,85,85,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,85,80,
0,0,21,21,85,80,
0,0,21,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,85,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,85,84,21,1,80,
1,85,85,21,1,80,
0,85,85,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
0,85,84,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,84,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,80,0,21,1,80,
1,85,84,21,1,80,
1,85,85,21,1,80,
1,85,85,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
0,85,84,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,84,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,85,80,
0,0,21,21,85,80,
0,0,21,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,84,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,1,80,
1,85,85,21,1,80,
1,85,85,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
0,85,84,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
0,85,84,5,85,64,
1,85,85,21,85,80,
1,85,85,21,85,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,1,80,
1,85,85,21,1,80,
0,85,85,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
0,0,21,21,1,80,
1,80,21,21,1,80,
1,80,21,21,1,80,
1,85,85,21,85,80,
1,85,85,21,85,80,
0,85,84,5,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
21,5,85,1,85,64,
21,21,85,69,85,80,
21,21,85,69,85,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,5,69,65,80,
21,21,85,69,85,80,
21,21,85,69,85,80,
21,5,85,1,85,64,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
21,0,5,85,64,85,
21,0,5,85,65,85,
21,0,5,85,65,85,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,81,
21,0,0,84,1,81,
21,0,0,84,1,81,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,0,0,84,1,80,
21,85,5,85,65,85,
21,85,5,85,65,85,
21,85,5,85,64,85,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,0,0,0,0,
84,5,64,84,21,85,
85,5,64,84,21,85,
85,5,64,84,21,85,
21,5,64,84,1,80,
21,5,64,84,1,80,
0,5,64,84,1,80,
0,5,64,84,1,80,
0,5,64,84,1,80,
84,5,85,84,1,80,
85,5,85,84,1,80,
85,5,85,84,1,80,
21,5,64,84,1,80,
21,5,64,84,1,80,
21,5,64,84,1,80,
21,5,64,84,1,80,
21,5,64,84,1,80,
21,5,64,84,1,80,
85,5,64,84,1,80,
85,5,64,84,1,80,
84,5,64,84,1,80,
0,0,0,0,0,0,
0,0,0,0,0,0},
//
{0,0,0,0,0,0,
0,0,5,80,0,0,
0,0,85,85,0,0,
0,1,86,149,64,0,
0,5,106,169,80,0,
0,21,170,170,84,0,
0,22,170,170,148,0,
0,86,169,106,149,0,
0,90,149,86,165,0,
0,90,150,150,165,0,
0,86,170,170,149,0,
0,22,169,106,148,0,
0,21,169,106,84,0,
0,5,106,169,80,0,
0,1,86,149,64,0,
0,0,85,85,0,0,
0,0,89,101,0,0,
0,0,90,165,0,0,
0,0,90,165,0,0,
0,0,90,165,0,0,
0,0,86,149,0,0,
0,0,21,84,0,0,
0,0,5,80,0,0,
0,0,0,0,0,0}
};

void    send_cmd(unsigned char cmd)
{
    LCD_DC=0;
    LATC=(unsigned int)cmd;
    LCD_WR=1;
    LCD_WR=0;
}

void    send_data(unsigned char data)
{
    LCD_DC=1;
    LATC=(unsigned int)data;
    LCD_WR=1;    
    LCD_WR=0;
}

void    send_data_2(unsigned char data1,unsigned char data2)
{
    LCD_DC=1;
    LATC=(unsigned int)data1;
    LCD_WR=1;
    LCD_WR=0;
    LATC=(unsigned int)data2;
    LCD_WR=1;
    LCD_WR=0;    
}

void    send_data_4(unsigned char data1,unsigned char data2,unsigned char data3,unsigned char data4)
{
    LCD_DC=1;
    LATC=(unsigned int)data1;
    LCD_WR=1;
    LCD_WR=0;
    LATC=(unsigned int)data2;
    LCD_WR=1;
    LCD_WR=0;
    LATC=(unsigned int)data3;
    LCD_WR=1;
    LCD_WR=0;
    LATC=(unsigned int)data4;
    LCD_WR=1;
    LCD_WR=0;    
}

void    disp_ram_clear(void)
{
    unsigned int    i;
    
    for(i=0;i<7680;i++){
        disp_ram[i]=0;
    }
}
void    disp_ram_set(void)
{
    unsigned int    i,j,x,y;
    unsigned char   n0,n1;
    
    for(j=0;j<26;j++){
        n0=disp_u_level[j];
        n1=disp_d_level[j];        
        for(y=0;y<48;y++){
            for(x=0;x<6;x++){
                i=j*6+y*160+x+2;
                if(y<24){
                    disp_ram[i]=vu_font[n0][y*6+x];
                }
                else{
                    disp_ram[i]=vu_font[n1][(y-24)*6+x];
                }
            }
        }
    }
}
void    disp_ud_set_2(unsigned int lv,unsigned int rv,unsigned char fn)
{
    unsigned char   i;

    for(i=1;i<=12;i++){
        disp_u_level[i]=24-i;
        disp_u_level[i+13]=24-i;
    }

    disp_u_level[0]=vu_font_no[fn];
    disp_u_level[13]=vu_font_no[fn];
    
    disp_d_level[0]=0;
    disp_d_level[13]=1;
    
    for(i=0;i<12;i++){
        if(i<lv){
            if(i>6){
                disp_d_level[i+1]=vu_font_no[fn]+1;
            }
            else{
                disp_d_level[i+1]=vu_font_no[fn];
            }
        }
        else{
            disp_d_level[i+1]=4;
        }

        if(i<rv){
            if(i>6){
                disp_d_level[i+14]=vu_font_no[fn]+1;
            }
            else{
                disp_d_level[i+14]=vu_font_no[fn];
            }
        }
        else{
            disp_d_level[i+14]=4;
        }
    }    

}
void    disp_ud_set_light(unsigned int lt)
{
    unsigned char   i;

    for(i=12;i<=25;i++){
        disp_u_level[i]=11;
        disp_d_level[i]=11;
    }
    disp_u_level[0]=11;
    disp_u_level[1]=11;
    disp_d_level[0]=50;
    disp_d_level[1]=51;
    for(i=2;i<=11;i++){
        disp_u_level[i]=38+i;
    }
   
    lt=lt/10;
    for(i=0;i<10;i++){
        if(i<lt){
            disp_d_level[i+2]=52;
        }
        else{
            disp_d_level[i+2]=4;
        }
    }
}
void    disp_lr_clear(void)
{
    unsigned char   i;
    
    for(i=0;i<26;i++){
        disp_u_level[i]=0;
        disp_d_level[i]=0;
    }
}
void    set_up(void)
{
    LCD_RST=1;
    LCD_WR=0;
    LCD_RD=1;
    __delay_ms(10);
    LCD_CS=0;

    send_cmd(0xc8);
    send_data(0xff);
    send_data(0x93);
    send_data(0x42);
    
    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);

    send_cmd(0x36);
    send_data(0xc8);

    send_cmd(0xc0);
    send_data(0x0e);
    send_data(0x0e);

    send_cmd(0xc1);
    send_data(0x10);

    send_cmd(0xc5);
    send_data(0xfa);

    send_cmd(0x3a);
    send_data(0x55);

    send_cmd(0xb1);
    send_data(0x00);
    send_data(0x18);

    send_cmd(0xe0);
    send_data(0x00);
    send_data(0x1c);
    send_data(0x21);
    send_data(0x02);
    send_data(0x11);
    send_data(0x07);
    send_data(0x3d);
    send_data(0x79);
    send_data(0x4b);
    send_data(0x07);
    send_data(0x0f);
    send_data(0x0c);
    send_data(0x1b);
    send_data(0x1f);
    send_data(0x0f);

    send_cmd(0xe1);
    send_data(0x00);
    send_data(0x1c);
    send_data(0x20);
    send_data(0x04);
    send_data(0x0f);
    send_data(0x04);
    send_data(0x33);
    send_data(0x45);
    send_data(0x42);
    send_data(0x04);
    send_data(0x0c);
    send_data(0x0a);
    send_data(0x22);
    send_data(0x29);
    send_data(0x0f);

    send_cmd(0x11);
    __delay_ms(130);

    send_cmd(0x29);
    __delay_ms(10);
    
}
void    disp_clear(void)
{
    unsigned int    i;
    
    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);
    send_cmd(0x2c);

    for (i = 0; i < 30720; i++)
    {
        send_data_2(8,33);
    }    
}

void    test_lcd(void){
    unsigned int    i,x;
    unsigned char   n;
    
    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);
    send_cmd(0x2c);
    
    x=0;
    for (i = 0;i < 30720; i++){
        n=(unsigned char)(x/46)+1;
        if (x >= 639){
            x = 0;
        }
        else{
            x++;
        }
        send_data_2(color_data1[n],color_data2[n]);
    }    
}

void    disp_main(unsigned char pal)
{
    unsigned int    i;
    unsigned char   data1,data2,data3,data4;
    unsigned char   d_palet[4];
    unsigned char   rd;
    
    d_palet[0]=color_palet[pal][0];
    d_palet[1]=color_palet[pal][1];
    d_palet[2]=color_palet[pal][2];
    d_palet[3]=color_palet[pal][3];

    send_cmd(0x2a);
    send_data_4(0x00,0x00,0x01,0x3f);
    send_cmd(0x2b);
    send_data_4(0x00,0x00,0x00,0x5f);
    send_cmd(0x2c);
    
    LCD_DC=1;
    
    for (i=0;i<7680;i++){
        
        rd=disp_ram[i];
        data1=d_palet[rd/64];
        data2=d_palet[(rd/16) & 0x03];
        data3=d_palet[(rd/4) & 0x03];
        data4=d_palet[rd & 0x03];

        //LCD_DC=1;
        LATC=color_data1[data1];
        LCD_WR=1;
        LCD_WR=0;
        LATC=color_data2[data1];
        LCD_WR=1;
        LCD_WR=0;
        LATC=color_data1[data2];
        LCD_WR=1;
        LCD_WR=0;
        LATC=color_data2[data2];
        LCD_WR=1;
        LCD_WR=0;    
        LATC=color_data1[data3];
        LCD_WR=1;
        LCD_WR=0;
        LATC=color_data2[data3];
        LCD_WR=1;
        LCD_WR=0;
        LATC=color_data1[data4];
        LCD_WR=1;
        LCD_WR=0;
        LATC=color_data2[data4];
        LCD_WR=1;
        LCD_WR=0;  

    }
}
//------------------AD------------------------
void    ad_init(void)
{
    AD1CON1   = 0b0000000000000000 ;
    AD1CON2   = 0b0000000000000000 ;
    AD1CON3   = 0x0001;
    AD1CON1bits.ADON = 1 ;    
}
void    ad_input(void)
{
    AD1CHS = 0x00;
    AD1CON1bits.SAMP = 1;
    __delay_us(3) ; 
    AD1CON1bits.SAMP = 0 ;
    while (!AD1CON1bits.DONE) ;
    ad0_level = ADC1BUF0 ; 
    
    AD1CHS = 0x01;
    AD1CON1bits.SAMP = 1;
    __delay_us(3) ; 
    AD1CON1bits.SAMP = 0 ;
    while (!AD1CON1bits.DONE) ;
    ad1_level = ADC1BUF0 ;       
}
void    ad_henkan(void)
{
    l_level=ad0_level;
    l_level=l_level/4;
    if(l_level>255){
        l_level=255;
    }
    l_level=vu_data[l_level];
    
    r_level=ad1_level;
    r_level=r_level/4;
    if(r_level>255){
        r_level=255;
    }
    r_level=vu_data[r_level];
}
void    ad_henkan_2(void)
{
    l_level=ad0_level;
    l_level=l_level/4;
    if(l_level>255){
        l_level=255;
    }
    l_level=vu_data_2[l_level];
    
    r_level=ad1_level;
    r_level=r_level/4;
    if(r_level>255){
        r_level=255;
    }
    r_level=vu_data_2[r_level];
}
//------------------PWM-----------------------
void    back_light_set(unsigned int no)
{
    unsigned int    count;
    
    if(no==100){
        count=65535;
    }
    else{
        count=no*655;
    }
    OC1_SecondaryValueSet(count);

}
//***************************************************************
//I2C
//***************************************************************
void i2c_start() {
    I2C1CONbits.SEN = 1;
    while (I2C1CONbits.SEN) {
    }
}
void i2c_restart() {
    I2C1CONbits.RSEN = 1; 
    while (I2C1CONbits.RSEN) {
    }
}
void i2c_stop() {
    I2C1CONbits.PEN = 1; 
    while (I2C1CONbits.PEN) {
    }
}
void i2c_send(unsigned char data) {
    unsigned char i;
    I2C1TRN = data;
    while (I2C1STATbits.TRSTAT) {
    }
    for(i=0;i<10;i++){
    }
}
void i2c_data1_write(unsigned char i2c_addr,unsigned char addr,unsigned char *data)
{
    i2c_start();
    i2c_send(i2c_addr);
    i2c_send(0x00);
    i2c_send(addr);
    i2c_send(*data);
    i2c_stop();
}
void i2c_data1_read(unsigned char i2c_addr,unsigned char addr,unsigned char *dd)
{
    i2c_start();
    i2c_send(i2c_addr);
    i2c_send(0x00);
    i2c_send(addr);
    i2c_start();
    i2c_send(i2c_addr | 0x01);    
    I2C1CONbits.RCEN = 1; 
    while (I2C1CONbits.RCEN) {
    }
    i2c_stop();    
    dd[0]=I2C1RCV;
}
void eeprom_write(unsigned char n0,unsigned char n1)
{
    data[0]=n0;
    i2c_data1_write(I2C_EEPROM,0x20,data);
    data[0]=n1;
    i2c_data1_write(I2C_EEPROM,0x21,data);    
}
int main(void)
{
    unsigned char   pal_no,font_no;
    
    // initialize the device
    SYSTEM_Initialize();

    set_up();
    test_lcd();
    __delay_ms(1000);
    mode=0;
    
    i2c_data1_read(I2C_EEPROM,0x10,data);
    if(data[0]==0xaa){
        i2c_data1_read(I2C_EEPROM,0x20,data);
        pal_no=data[0];
        i2c_data1_read(I2C_EEPROM,0x21,data);
        font_no=data[0];
        i2c_data1_read(I2C_EEPROM,0x22,data);
        light=data[0];        
    }
    else{
        data[0]=0xaa;
        i2c_data1_write(I2C_EEPROM,0x10,data);
        __delay_us(1000);
        pal_no=0;
        font_no=0;
        light=100;
        
        data[0]=pal_no;
        i2c_data1_write(I2C_EEPROM,0x20,data);
        __delay_us(1000);
        data[0]=font_no;
        i2c_data1_write(I2C_EEPROM,0x21,data);
        __delay_us(1000);        
        data[0]=light;
        i2c_data1_write(I2C_EEPROM,0x22,data);        
    }
    
    disp_ram_clear();
    
    back_light_set(light);
    OC1_Start();
    
    ad_init();
    
    while (1)
    {
		/* key scan 1 */
		if (SW1==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if (SW2==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if (SW3==0){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/        
        switch(mode){
            case 0:
                ad_input();
                ad_henkan_2();
                disp_ud_set_2(l_level,r_level,font_no);
                disp_ram_set();
                TEST_PORT=1;
                disp_main(pal_no);
                TEST_PORT=0;                
                break;
            case 1:
                disp_ud_set_light(light);
                disp_ram_set();
                TEST_PORT=1;
                disp_main(pal_no);
                TEST_PORT=0;                
                break;
        }

		/* key scan 2 */
		if ((SW1==0)&&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if ((SW2==0)&&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/ 
		if ((SW3==0)&&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/         
		/* key action */
		if((sw1_key==0)&&(sw1_rep==0)){
			sw1_rep=1;
            switch(mode){
                case 0:
                    pal_no++;
                    if(pal_no>=7){
                        pal_no=0;
                    }
                    data[0]=pal_no;
                    i2c_data1_write(I2C_EEPROM,0x20,data);                    
                    break;
                case 1:
                   if(light==100){
                        
                    }
                    else{
                        if(light<100){
                            light=light+10;
                            back_light_set(light);
                        }                        
                    }
                    data[0]=light;
                    i2c_data1_write(I2C_EEPROM,0x22,data);                   
                    break;
            }
		}
        /*------------------*/
		if((sw2_key==0)&&(sw2_rep==0)){
			sw2_rep=1;
            switch(mode){
                case 0:
                    font_no++;
                    if(font_no>=12){
                        font_no=0;
                    }
                    data[0]=font_no;
                    i2c_data1_write(I2C_EEPROM,0x21,data);                    
                    break;
                case 1:
                    if(light==10){
                        
                    }
                    else{
                        if(light>10){
                            light=light-10;
                            back_light_set(light);
                        }
                    }
                    data[0]=light;
                    i2c_data1_write(I2C_EEPROM,0x22,data);                   
                    break;
            }
		}
        /*------------------*/
		if((sw3_key==0)&&(sw3_rep==0)){
			sw3_rep=1;
            switch(mode){
                case 0:
                    break;
                case 1:
                    mode=0;
                    break;
            }
		}
        /*------------------*/
		if((sw3_key==0)&&(sw3_rep==1)){
            switch(mode){
                case 0:
                    sw3_cnt++;
                    if(sw3_cnt>=50){
                        sw3_cnt=0;
                        mode=1;
                    }
                    break;
                case 1:
                    break;
            }
        }
        /*------------------*/        
    }

    return 1;
}
/**
 End of File
*/

